#! /bin/bash
# Este Shell tem por finalidade gerar os dp's a partir de um arquivo 
# visualizavel em GrADS. (combinado com o geraBIN.gs e o geraDP.x(f90))
#
# Demerval S. Moreira (demervalsm@gmail.com) 02/Mai/2003
#

#para executar automaticamente basta executar como segue o exemplo: 
#  /usr/local/bin/geraDP.sh /p1/ramsop/opera/grads/2g_030502001.ctl   u     v   tempk  geo  ur  7 -999 -999 -999 -999 N
#                                                                   (m/s) (m/s)  (K)   (m) (%)
#
#-> O 7 indica que possui umidade relativa para os primeiros sete niveis. 
#-> Caso queira definir uma area menor basta substituir os -999 por: lati latf loni lonf
#-> Caso o binario j estja no formato de leitura do fortran, substitua o "N" por "S"
#
#PS: Os arquivos geraDP.sh, geraDP.gs e geraDP.x devem estar no mesmo diretorio.
                                                                                         
#export GAUDFT=/shared/home/ramsop/util/udft.regrid2

grads=grads
DIR_fonte=`dirname $0`
DIR_dp=`pwd`
clear
echo "The DP files will be generated in the current working directory: "`pwd` 
########################
nome=$1
u=$2
v=$3
temp=$4
geo=$5
ur=$6
zmax=$7
lat2i=$8
lat2f=$9
lon2i=${10}
lon2f=${11}
to_f90=${12}
########################
echo; echo "The following ctl files was found in this dir:"; echo 
if [ x$1 = "x" ]
then
  ls -1 *.ctl *.nc
  echo;echo -n "Enter the CTL filename or .nc (ex: /home/user/avn/avn.ctl)=> "
  read nome
#  nome="/p1/ramsop/opera/grads/2g_030502001.ctl" #tmp
#  nome="glob1.ctl" #tmp
  echo;echo -n 'The binary file is already formated to be read by the fortran program - In doubt, choose "N" (y/N): '
  read to_f90
fi

nc=$(echo $nome | awk -F "." '{print $NF}')

if [ $nc != 'nc' ]; then
   nX=`grep -i xdef $nome | awk '{print $2}'` 
   loni=`grep -i xdef $nome | awk '{print $4}'` 
   intX=`grep -i xdef $nome | awk '{print $5}'` 
   nY=`grep -i ydef $nome | awk '{print $2}'` 
   lati=`grep -i ydef $nome | awk '{print $4}'` 
   intY=`grep -i ydef $nome | awk '{print $5}'` 
   nlev=`grep -i zdef $nome | awk '{print $2}'` 
   nt=`grep -i tdef $nome | awk '{print $2}'` 
   indef=`grep -i UNDEF $nome | awk '{print $2}'` 
   linear=`grep -i ydef $nome | awk '{print substr($3,2,1)}'`
   linearx=`grep -i xdef $nome | awk '{print substr($3,2,1)}'`
else
   grads -clb "sdfopen $nome" << EOF 
     q ctlinfo
     quit
EOF
   echo
   echo "Com as informacoes descritas acima, informar:"
   echo -n "indef (valor do indefinido): "
   read indef
   echo -n "nX (numero de pontos em X): "
   read nX
   echo -n "loni (longitude inicial): "
   read loni
   echo -n "intX (espacamento em X): "
   read intX
   echo -n "nY (numero de pontos em Y): "
   read nY
   echo -n "lati (latitude inicial): "
   read lati
   echo -n "intY (espacamento em Y): "
   read intY
   echo -n "nlev (numero de niveis): "
   read nlev
   echo -n "nt (numero de tempos): "
   read nt
   linear='i'
   linearx='i'
fi   

if [ $linear = 'e' -o $linear = 'E' -o  $linearx = 'e' -o $linearx = 'E' ];then
  echo;echo "X or Y spacing is not linear, use a type of regrid to convert the grid to linear.Quiting..."
  exit
fi  
#echo "--->"$indef"|"
#exit
cd $DIR_dp
if test -s $DIR_dp/dims.txt; then rm -f $DIR_dp/dims.txt; fi
if [ x$to_f90 = "xY" -o x$to_f90 = "xy" ]; then
  Nbin=`grep -i dset $nome | awk '{print $2}'` 
  tem=`echo $Nbin | grep "\^" | wc -l`
  if [ $tem -eq 1 ];then Nbin=`dirname $nome`/`echo $Nbin | sed s%"\^"%%g`; fi
  if test ! -s $Nbin; then echo;echo "The binary file was not found: $Nbin    Quiting...";exit;fi
  echo $Nbin

  $grads -clb "run $DIR_fonte/geraBIN.gs $nome $nX $loni $intX $nY $lati $intY $nlev $nt $indef $linear S $nc $u $v $temp $geo $ur $zmax $lat2i $lat2f $lon2i $lon2f"
else
	echo "------------- Generating the binary file to be read by the fortran program ---------------------"
  #echo $nome $nX $loni $intX $nY $lati $intY $nlev $nt $indef $linear $u $v $temp $geo $ur $zmax $lat2i $lat2f $lon2i $lon2f N
  $grads -clb "run $DIR_fonte/geraBIN.gs $nome $nX $loni $intX $nY $lati $intY $nlev $nt $indef $linear N $nc $u $v $temp $geo $ur $zmax $lat2i $lat2f $lon2i $lon2f"
  echo "------------- Binary file generated ---------------------"
  Nbin=$DIR_dp/'to_dp.gra'
fi

tam=`ls -l $Nbin | awk '{print $5}'`

echo "------------- Generating the DP files ---------------------"
$DIR_fonte/geraDP.x $Nbin $tam $DIR_dp'/'
rm -f $DIR_dp/dims.txt
if [ x$to_f90 = "xS" -o x$to_f90 = "xs" ]; then
	echo "Keeping the file $Nbin"
else
	echo "Removing the file $Nbin"
  rm -f $Nbin
fi

exit





